/*
 * CameraCapture.h
 *
 *  Created on: 9 dec. 2011
 *      Author: henrique
 */

#ifndef CAMERACAPTURE_H_
#define CAMERACAPTURE_H_

#include <stdio.h>
#include <cv.h>
#include <highgui.h>

class CameraCapture {

public:
	CameraCapture();

	/*
	 * Get camera frame
	 */
	IplImage * getImage();

	virtual ~CameraCapture();

private:

	/*
	 * Handles the camera device
	 */
	CvCapture * capture;

	/*
	 * Keep in memory the last captured frame
	 */
	IplImage * lastImage;

	/*
	 * Image width which is used to the matrix indexing on the linear way
	 */
	int imageWidth;

	/*
	 * View window name
	 */
	const char * windowName;
};

#endif /* CAMERACAPTURE_H_ */
