/*
 * Global.h
 *
 *  Created on: 6 janv. 2012
 *      Author: chafeek
 */

#ifndef GLOBAL_H_
#define GLOBAL_H_

#define COMMANDE_SHOOT 's'
#define COMMANDE_WALK 'w'
#define COMMANDE_TURN 't'
#define FIELD_LENGHT 640
#define FIELD_WIDTH 480

#define HOME_LINE 550

#define EPSILON_MOUVEMENT_BALLE 10
#define EPSILON_MOVEMENT_ROBOT 100

#define MINIMUM_COMMANDE_INTERVAL 100000

#define REAL_LENGTH 166.0
#define REAL_WIDTH 104.0



#include <mqueue.h>

//moitié du terrain 81 cm, la bande 3.5, largeur entre les deux machins 90, les pti machins 7 chacun

struct msgIaToKhepera
{
		long mtype;
        char commande;
        //parameters
        int robot;
        int p1;
        int p2;
        int p3;
        int p4;
};

struct msgImageToIa
{
	long mtype;
	int xBall;
	int yBall;
	int xLeftRobot;
	int yLeftRobot;
	int xRightRobot;
	int yRightRobot;
	int angleLeftRobot;
	int angleRightRobot;

};

extern mqd_t msgQueueIaToKhepera;
extern mqd_t msgQueueImageToIa;
extern bool inAttackMode;

#define CORNERS 4
#define LBCORNER 0
#define RBCORNER 1
#define LUCORNER 2
#define RUCORNER 3

#define COLORS 3
#define ROBOT_WHITE_COLOR 0
#define ROBOT_BLUE_COLOR 1
#define BALL_COLOR 2

#define EPISILON 10
#define FIELD_TOLERANCE 20
#define MAX_TOLERANCE 255

/*
 * Element position in the field
 */
typedef struct {
	int x, y;
} Position, BallPosition, Corner;

/*
 * Robot position and angle informations
 */
typedef struct {
	Position position;
	unsigned int angle;
} RobotInfo;

#endif /* GLOBAL_H_ */
