/*
 * IAThread.cpp
 *
 *  Created on: 7 janv. 2012
 *      Author: chafeek
 */

#include "IAThread.h"
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream>
#include "Global.h"

//#define MAP

extern mqd_t msgQueueIaToKhepera;
extern mqd_t msgQueueImageToIa;
extern double alpha0;
extern double alpha1;

using namespace std;

int xBallOld;
int yBallOld;

int xOldPositionR0;
int yOldPositionR0;

int xOldPositionR1;
int yOldPositionR1;

int xDestinationR0Old;
int yDestinationR0Old;

int xDestinationR1Old;
int yDestinationR1Old;

int xBall;
int yBall;
int xLeftRobot;
int yLeftRobot;
int xRightRobot;
int yRightRobot;

double a;
double b;
int xImpact;

extern bool inAttackMode;

unsigned int prio = 0;

IAThread::IAThread() {}

void IAThread::start(){pthread_create(&thread, NULL, run, NULL);}

void IAThread::stop(){//TODO : arreter le thread
}

void IAThread::sendMovement(int robot)
{
	int xRobot;
	int yRobot;
	int xDestinationROld;
	int yDestinationROld;
	int alpha;

	if(robot == 1) return;

	switch(robot)
	{
	case 0 :
	{
		xRobot = xLeftRobot;
		yRobot = yLeftRobot;
		xDestinationROld = xDestinationR0Old;
		yDestinationROld = yDestinationR0Old;
		alpha = alpha0;
	}
	break;

	case 1 :
	{
		xRobot = xRightRobot;
		yRobot = yRightRobot;
		xDestinationROld = xDestinationR1Old;
		yDestinationROld = yDestinationR1Old;
		alpha = alpha1;
	}
	break;
	}


	//la nouvelle destination étant , HOME_LINE et ximpact
	if(abs(xImpact - xDestinationROld) > EPSILON_MOVEMENT_ROBOT || abs(HOME_LINE - yDestinationROld) > EPSILON_MOVEMENT_ROBOT)
	{

		struct msgIaToKhepera msgToSend;

		//calculer l'angle
		double angle = angleToTurn(xRobot, yRobot, xImpact, HOME_LINE, alpha);

		//Dire au robot de tourner
		msgToSend.mtype = 2;
		msgToSend.robot = robot;
		msgToSend.commande = COMMANDE_TURN;
		msgToSend.p1 = (int)angle; //angle
		msgToSend.p2 = 1;
		alpha = (int) (alpha + angle)%360;

		//TODO : Attention décommenter après les tests

		mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);

		//Il faut envoyer la nouvelle destination au robot left R0

		msgToSend.commande = COMMANDE_WALK;

		double distance = getRealDistance(xRobot, yRobot, xImpact, HOME_LINE);
		msgToSend.p1 = distance;
		mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);

		showMessage(0, angle, distance);

		switch(robot)
		{
		case 0 :
		{
			alpha0 = alpha;
			xDestinationR0Old = xImpact;
			yDestinationR0Old = HOME_LINE;
			cout<<"Alpha = "<<alpha0<<endl;
		}
		break;

		case 1 :
		{
			alpha1 = alpha;
			xDestinationR1Old = xImpact;
			yDestinationR1Old = HOME_LINE;
		}
		break;
		}

	}
}

void IAThread::initPositions()
{
	unsigned int prio = 0;
	struct msgImageToIa msgReceived;
	//msgrcv(msgQueueImageToIa, &msgReceived, sizeof(struct msgImageToIa)-sizeof(long), 1, 0);
	mq_receive (msgQueueImageToIa, (char*)&msgReceived, sizeof(struct msgImageToIa), &prio);

	//Où est la balle ?
	xBallOld = msgReceived.xBall;
	yBallOld= msgReceived.yBall;

	xOldPositionR0 = msgReceived.xLeftRobot;
	yOldPositionR0 = msgReceived.yLeftRobot;

	xOldPositionR1 = msgReceived.xRightRobot;
	yOldPositionR1 = msgReceived.yRightRobot;
}

void IAThread::setPositions()
{
	unsigned int prio = 0;
	struct msgImageToIa msgReceived;

	//msgrcv(msgQueueImageToIa, &msgReceived, sizeof(struct msgImageToIa)-sizeof(long), 1, 0);
	mq_receive (msgQueueImageToIa, (char*)&msgReceived, sizeof(struct msgImageToIa), &prio);

	//Où est la balle ?
	xBall = msgReceived.xBall;
	yBall = msgReceived.yBall;
	xLeftRobot = msgReceived.xLeftRobot;
	yLeftRobot = msgReceived.yLeftRobot;
	xRightRobot = msgReceived.xRightRobot;
	yRightRobot = msgReceived.yRightRobot;
}

void IAThread::initAll()
{
	// Reception des positions de la balle et des robots à l'init
	initPositions();

	showMessage(1, 0, 0);

	xDestinationR0Old= -1;
	yDestinationR0Old= -1;

	xDestinationR1Old= -1;
	yDestinationR1Old= -1;

	alpha0 = 0;
	alpha1 = 180;
}

void IAThread::setABI()
{
	if (xBallOld != xBall) {
		a = (yBallOld - yBall) / (xBallOld - xBall);
		b = yBall - a*xBall;

		xImpact = ((double) HOME_LINE - b) / a;
		if (xImpact < 0) {
			printf("qhk sgdfjkqsgjkfqsd jkf\n");
		}
	}
	else
		xImpact = xBall;
}

void IAThread::actualiseBall()
{
	xBallOld = xBall;
	yBallOld = yBall;
}

void IAThread::showMessage(int messId, double p1, double p2)
{
#ifdef MAP
	switch(messId)
	{
	case 0 :
	{
		cout<<"La nouvelle destination ayant changée, le robot0 doit tourner de "<<p1<<" deg et marcher "<<p2<<" cm "<<endl;
	}
	break;
	case 1 :
	{
		cout<<"Initialisation : "<< "XBall = " << xBallOld<<" YBall = "<<yBallOld<<"XR0 = "<<xOldPositionR0<<" YR0 = "<<yOldPositionR0<<"XR1 = "<<xOldPositionR1<<" YR1 = "<<yOldPositionR1<<endl;
	}
	break;
	case 2 :
	{
		cout<<"La balle vient vers nous"<<endl;
		cout<<"Anciennes coordonnées de la balle : " << "X = "<<xBallOld<<" Y = "<<yBallOld<<endl;
		cout<<"Nouveles coordonnées de la balle : " << "X = "<<xBall<<" Y = "<<yBall<<endl;
	}
	break;
	case 3 :
	{
		cout<<"Point d'impact prévu : "<<"X = "<<xImpact<<" Y = "<<HOME_LINE<<endl;
	}
	break;
	case 4 :
	{
		cout<<"Plusieurs rebonds prévus on ne fait rien"<<endl;
	}
	break;
	case 5 :
	{
		cout<<"Il y a eu rebond, on envoit le robot0"<<endl;
		cout<<"L'ancienne destination est : X = "<<xDestinationR0Old<<" Y = "<<yDestinationR0Old<<endl;
	}
	break;
	case 6 :
	{
		cout<<"Pas de rebonds, on envoit le robot0"<<endl;
		cout<<"L'ancienne destination est : X = "<<xDestinationR0Old<<" Y = "<<yDestinationR0Old<<endl;
	}
	break;
	case 7 :
	{
		cout<<"La balle est dans leurs camps et va vers eux, il ne faut rien faire."<<endl;
	}
	break;
	case 8 :
	{
		cout<<"La balle vient vers nous il faut implémenter la stratégie dattaque !"<<endl;
	}
	break;
	case 9 :
	{
		cout<<"IL fqut shooter"<<endl;
	}
	break;
	}
#endif
}

void* IAThread::run(void* data)
{

#ifdef MAP
	cout<<"Thread IA lancé"<<endl;
#endif

	// Initialisation de tout le bazar!
	initAll();

	while (true)
	{
		// fixer les positions balle et robots
		setPositions();

		//		int angleLeftRobot = msgReceived.angleLeftRobot;
		//		int angleRightRobot = msgReceived.angleRightRobot;

		if (yBall < FIELD_LENGHT/2) //La balle est dans le camps adverse
		{
			//calcul de la direction de la balle
			if (yBall - yBallOld > EPSILON_MOUVEMENT_BALLE && !inAttackMode) //La balle vient vers nous
			{
				showMessage(2, 0, 0);
				//Anticiper  le point d'impact sur la ligne HOME
				setABI();
				showMessage(3, 0, 0);

				//Test si pas de rebond
				if (xImpact < 0)
				{
					xImpact *= -1;
					if (xImpact > FIELD_WIDTH)
					{
						showMessage(4, 0, 0);
					}
					else //Décider quel robot envoyer
					{
						if (xImpact < FIELD_WIDTH/2) //RobotLeft
						{
							//Verifier l'ancienne destination du robotleft
							showMessage(5, 0, 0);
							//la nouvelle destination étant , HOME_LINE et ximpact
							sendMovement(0);
							//Ne pas oublier de mettre à jour l'angle
						}

						else
						{
							//Verifier l'ancienne destination du robotright
							//la nouvelle destination étant , HOME_LINE et ximpact
							sendMovement(1);
						}
						//Envoyer ordre au robot si ce n'est déja fait
					}
				}
				else if (xImpact > FIELD_WIDTH)
				{
					xImpact = 2*FIELD_WIDTH - xImpact ;
					if (xImpact < 0)
					{
						showMessage(4, 0, 0);
						//Ne rien faire, plusieurs rebonds, la vitesse va forcément s'atténuer
					}
					else //Décider quel robot envoyer
					{
						if(xImpact < FIELD_WIDTH/2)
						{
							//Verifier l'ancienne destination du robotleft
							//la nouvelle destination étant , HOME_LINE et ximpact
							sendMovement(0);
						}
						else
						{
							sendMovement(1);
						}
					}
				}
				else //pas de rebonds, envoyer le bon robot
				{

					if (xImpact < FIELD_WIDTH/2) //RobotLeft
					{
						//Verifier l'ancienne destination du robotleft
						showMessage(6, 0, 0);
						//la nouvelle destination étant , HOME_LINE et ximpact
						sendMovement(0);

						//Ne pas oublier de mettre à jour l'angle
					}

					else
					{
						//Verifier l'ancienne destination du robotright
						//la nouvelle destination étant , HOME_LINE et ximpact
						sendMovement(1);
					}
				}

			}
			else if (yBallOld - yBall > EPSILON_MOUVEMENT_BALLE)
			{
				showMessage(7, 0, 0);
				//Elle va vers eux, ne rien faire
			}
		}
		else //La balle est dans notre camps // Stratégie attaque
		{

			if (abs(yBall - yBallOld) > 20) //La balle va vite
			{
				if (yBall > yBallOld)// Elle viens vers nous, il faut défendre, ou on a déja défendu
				{

				}
				else
				{
					//On a déja shooté
					//il faut que le robot retourne à la maison ^^, les deux robots

					//sendMovement(0);
					//sendMovement(1);


				}
				showMessage(8, 0, 0);
			}
			else if (!inAttackMode)
			{
				inAttackMode = true;
				//Shoot
				//XXX
				//D'abord où est la balle robot0 ou robot1
				//if xBall ...
				//if (xBall < )
				if (xBall < FIELD_WIDTH/2) //RobotLeft
					//TODO faire la mm chose pour le robot right
				{


					//TODO : On teste si on est dans la zone critique
					//Demander au robot d'aller a la destination  xball + 20, yRobot
					//Demander au robot d'aller à xBall, yBall-10
					//TODO :On regarde alpha et on shoot
					struct msgIaToKhepera msgToSend;
					double angle;
					//angle = angleToTurn(xLeftRobot, yLeftRobot, xBall+20, yLeftRobot, alpha0);

					//Dire au robot daller vers la premiere destination
					msgToSend.mtype = 2;
					msgToSend.robot = 0;
					msgToSend.commande = COMMANDE_TURN;

					if(xLeftRobot < xBall)
						angle = 360 - alpha0;
					else
						angle = 180 - alpha0;



					msgToSend.p1 = (int)angle; //angle
					msgToSend.p2 = 2;
					alpha0 = (int) (alpha0 + angle)%360;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);


					msgToSend.commande = COMMANDE_WALK;

					double distance = getRealDistance(xLeftRobot, yLeftRobot, xBall+20, yLeftRobot);
					msgToSend.p1 = distance;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);
					//dire au robot daller a la seconde destination

					//angle = angleToTurn(xBall+20, yLeftRobot,xLeftRobot , yBall, alpha0);

					//Dire au robot daller vers la premiere destination
					msgToSend.mtype = 2;
					msgToSend.robot = 0;
					msgToSend.commande = COMMANDE_TURN;

					if(yLeftRobot > yBall)
						angle = 90;
					else
						angle = 270;

					msgToSend.p1 = angle; //angle
					alpha0 = (int) (alpha0 + angle)%360;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);

					//Il faut envoyer la nouvelle destination au robot left R0

					msgToSend.commande = COMMANDE_WALK;

					distance = getRealDistance(xBall+20, yLeftRobot,xLeftRobot , yBall+30);
					msgToSend.p1 = distance;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);
					msgToSend.mtype = 2;
					msgToSend.robot = 0;
					msgToSend.commande = COMMANDE_SHOOT;
					msgToSend.p1 = (int)(-359); //angle
					//alpha0 = (int) (alpha0 -359 )%360;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);



				}
				else
				{
					struct msgIaToKhepera msgToSend;
					double angle;
					//angle = angleToTurn(xLeftRobot, yLeftRobot, xBall+20, yLeftRobot, alpha0);

					//Dire au robot daller vers la premiere destination
					msgToSend.mtype = 2;
					msgToSend.robot = 1;
					msgToSend.commande = COMMANDE_TURN;

					if(xRightRobot < xBall)
						angle = 360 - alpha1;
					else
						angle = 180 - alpha1;



					msgToSend.p1 = (int)angle; //angle
					msgToSend.p2 = 2
					alpha1 = (int) (alpha1 + angle)%360;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);


					msgToSend.commande = COMMANDE_WALK;

					double distance = getRealDistance(xRightRobot, yRightRobot, xBall+20, yRightRobot);
					msgToSend.p1 = distance;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);
					//dire au robot daller a la seconde destination

					//angle = angleToTurn(xBall+20, yLeftRobot,xLeftRobot , yBall, alpha0);

					//Dire au robot daller vers la premiere destination
					msgToSend.mtype = 2;
					msgToSend.robot = 1;
					msgToSend.commande = COMMANDE_TURN;

					if(yRightRobot > yBall)
						angle = 90;
					else
						angle = 270;

					msgToSend.p1 = angle; //angle
					alpha1 = (int) (alpha1 + angle)%360;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);

					//Il faut envoyer la nouvelle destination au robot left R0

					msgToSend.commande = COMMANDE_WALK;

					distance = getRealDistance(xBall+20, yRightRobot,xRightRobot , yBall+30);
					msgToSend.p1 = distance;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);
					msgToSend.mtype = 2;
					msgToSend.robot = 1;
					msgToSend.commande = COMMANDE_SHOOT;
					msgToSend.p1 = (int)(-359); //angle
					//alpha0 = (int) (alpha0 -359 )%360;
					mq_send(msgQueueIaToKhepera, (char *) &msgToSend, sizeof(struct msgIaToKhepera), 0);


				}


				//Il faut shooter
			}
		}

		//Dans tous les cas mettre à jour les valeurs old

		actualiseBall();
	}

	return NULL;

}

double IAThread::angleToTurn(int xR, int yR, int xD, int yD, double alpha)
{

	//TODO cas particuliers

	if(xD == xR)
	{
		//l'histoire du pi/2
	}

	double gamma = atan((double)(yD-yR)/(double)(xD - xR) );
	if (gamma < 0) gamma*= -1;

	gamma = gamma*180/M_PI;

	if (xD > xR)
	{
		if (yD >= yR)
		{
			return 360.0 - (alpha + gamma);
		}
		else //yD < yR
		{
			return 360.0 - alpha + gamma;
		}
	}
	else //xD < xR
	{
		if (yD >= yR)
		{
			return 540.0 + gamma - alpha;
		}
		else //yD < yR
		{
			return 540.0 - gamma - alpha;
		}
	}
}

double IAThread::getRealDistance(int x1, int y1, int x2, int y2)
{

	int X = (x2 - x1)*(x2 - x1);
	int Y = (y2 - y1)*(y2 - y1);
	double alpha = (double)(REAL_LENGTH/FIELD_LENGHT)*(double)(REAL_LENGTH/FIELD_LENGHT);
	double beta = (double)(REAL_WIDTH/FIELD_WIDTH)*(double)(REAL_WIDTH/FIELD_WIDTH);

	return sqrt(alpha*X + beta*Y);
}

IAThread::~IAThread()
{
	// TODO Auto-generated destructor stub
}


