/*
 * IAThread.h
 *
 *  Created on: 7 janv. 2012
 *      Author: chafeek
 */

#ifndef IATHREAD_H_
#define IATHREAD_H_
#include <pthread.h>


class IAThread {
public:
	IAThread();
	void start();
	void stop();
	virtual ~IAThread();

private:
	pthread_t thread;
	static void* run(void* data);
	static double angleToTurn(int xRobot, int yRobot, int xDestination, int yDestination, double alpha);
	static double getRealDistance(int x1, int y1, int x2, int y2);
	static void sendMovement(int robot);
	static void initPositions();
	static void setPositions();
	static void initAll();
	static void setABI();
	static void actualiseBall();
	static void showMessage(int messId, double p1, double p2);
};

#endif /* IATHREAD_H_ */
