/*
 * ImageProcessing.h
 *
 *  Created on: Jan 6, 2012
 *      Author: henriquenogueira
 */

#ifndef IMAGEPROCESSING_H_
#define IMAGEPROCESSING_H_

#include <cv.h>
#include <highgui.h>

#include <pthread.h>

#include "Global.h"

class CameraCapture;

class ImageProcessing {
public:
	ImageProcessing();
	void init();
	void start();

	virtual ~ImageProcessing();
private:
	CameraCapture *cameraCapture;
	BallPosition ballPosition;
	RobotInfo rightRobotPosition;
	RobotInfo leftRobotPosition;
	Corner corners[CORNERS];
	int h, s, v;

	pthread_t thread;
	static void* run(void* data);

	void initField();
	void initColors();
	static void getObjectPosition(Position * position, IplImage *image, int initialX, int initialY, int finalX, int finalY);
	static void printMatrix(IplImage *image, int initialX, int initialY, int finalX, int finalY,  int xB, int yB);
	static void getRobotDirection(IplImage *image, int initialX, int initialY, int finalX, int finalY, Position * direction);

};

#endif /* IMAGEPROCESSING_H_ */
