/*
 * SerialCommunication.h
 *
 *  Created on: Nov 18, 2011
 *      Author: henriquenogueira
 */

#ifndef SERIALCOMMUNICATION_H_
#define SERIALCOMMUNICATION_H_

typedef enum {CLOSED, OPENED} SerialConnectionState;

#define MAX_RESPONSE_LENGHT 	25
#define BAUDRATE 				B9600
#define MESSAGE_END 			'\n'
#define MESSAGE_FORMAT 			"%s%c"

#include <termios.h>
#include <string>

class SerialCommunication {

public:
	SerialCommunication(std::string * device);
	void openConnection();
	void closeConnection();
	bool isOpened();
	std::string * sendMessage(std::string * command);
	std::string * getLastCommand();
	virtual ~SerialCommunication();

private:
	int fileDescriptor;
	std::string * deviceName;
	std::string * lastCommand;
	std::string * lastResponse;
	struct termios * configuration;
	SerialConnectionState connectionState;

};

#endif /* SERIALCOMMUNICATION_H_ */
