#include <iostream>
#include <string>

#include "KheperaController.h"
#include "ImageProcessing.h"

#include <stdio.h>
#include <stdlib.h>
#include "KheperaThread.h"
#include "IAThread.h"
#include <sys/msg.h>

#include <errno.h>
#include "Global.h"

using namespace std;

mqd_t msgQueueIaToKhepera;
mqd_t msgQueueImageToIa;
double alpha0 = 0;
double alpha1 = 0;
bool inAttackMode = false;

void simulerImage(int xB, int yB, int xR0, int yR0, int xR1, int yR1);
int getPixelX(double xCM);
int getPixelY(double yCM);

int main (int argc, char * argv[]) {

	struct msgIaToKhepera receivedDataIa;
	struct msgImageToIa receivedDataImage;
	unsigned int prio;
	struct mq_attr attr, attr2, old_attr, old_attr2;
	attr.mq_maxmsg = 100;
	attr.mq_msgsize = sizeof(struct msgIaToKhepera);
	attr.mq_flags = 0;
	if ((msgQueueIaToKhepera = mq_open ("/BalIAToKhepera", O_RDWR | !O_NONBLOCK | O_CREAT | O_EXCL, 0777, &attr)) == -1)
		msgQueueIaToKhepera = mq_open ("/BalIAToKhepera", O_RDWR | !O_NONBLOCK | O_EXCL, 0777, &attr);

	if (msgQueueIaToKhepera == -1) {
		perror ("mq_open()");
		_exit (EXIT_FAILURE);
	}

	attr2.mq_maxmsg = 100;
	attr2.mq_msgsize = sizeof(struct msgImageToIa);
	attr2.mq_flags = 0;

	if ((msgQueueImageToIa = mq_open ("/BalImageToIA", O_RDWR | !O_NONBLOCK | O_CREAT | O_EXCL, 0777, &attr2)) == -1)
		msgQueueImageToIa = mq_open ("/BalImageToIA", O_RDWR | !O_NONBLOCK | O_EXCL, 0777, &attr2);

	//Vérifier que la boite aux lettre est vide

	mq_unlink ("troy-mcclure");
	mq_getattr (msgQueueImageToIa, &attr);
	mq_getattr (msgQueueIaToKhepera, &attr2);

	if (attr.mq_curmsgs != 0) {

		// There are some messages on this queue....eat em

		// First set the queue to not block any calls
		// attr.mq_flags = O_NONBLOCK;
		mq_setattr (msgQueueImageToIa, &attr, &old_attr);

		// Now eat all of the messages
		while (attr.mq_curmsgs > 0 && mq_receive (msgQueueImageToIa, (char *) &receivedDataImage, sizeof(receivedDataImage), &prio) != -1)
			printf ("Received a message with priority %d.\n", prio);

		// The call failed.  Make sure errno is EAGAIN
		if (errno != EAGAIN) {
			perror ("mq_receive()");
			_exit (EXIT_FAILURE);
		}
		mq_setattr (msgQueueImageToIa, &old_attr, 0);


		printf ("%ld messages are currently on the queue.\n",
				attr.mq_curmsgs);
	}

	if (attr2.mq_curmsgs != 0) {

		// There are some messages on this queue....eat em

		// First set the queue to not block any calls
		// attr.mq_flags = O_NONBLOCK;
		mq_setattr (msgQueueIaToKhepera, &attr2, &old_attr2);

		// Now eat all of the messages
		while (attr2.mq_curmsgs > 0 && mq_receive (msgQueueIaToKhepera, (char *) &receivedDataIa, sizeof(receivedDataIa), &prio))
			printf ("BLAAAAA %d.\n", prio);

		// The call failed.  Make sure errno is EAGAIN
		if (errno != EAGAIN) {
			perror ("mq_receive()");
			_exit (EXIT_FAILURE);
		}
		mq_setattr (msgQueueIaToKhepera, &old_attr2, 0);


		printf ("%ld messages are currently on the queue.\n",
				attr2.mq_curmsgs);
	}

	//attr.mq_flags = O_RDWR | !O_NONBLOCK | O_CREAT | O_EXCL;
	//attr2.mq_flags = O_RDWR | !O_NONBLOCK | O_CREAT | O_EXCL;

	//mq_setattr(msgQueueIaToKhepera, &attr, &old_attr);
	//mq_setattr(msgQueueImageToIa, &attr2, &old_attr2);

	KheperaThread *kheperaThread = new KheperaThread();
	kheperaThread->start();
	IAThread *iaThread = new IAThread();
	iaThread->start();

	ImageProcessing *ip = new ImageProcessing();
	ip->init();
	ip->start();

	while(true)
	{

		sleep(100);
	}
	return 0;
}

int getPixelX(double xCM)
{
	return (FIELD_WIDTH/REAL_WIDTH)*xCM;
}
int getPixelY(double yCM)
{
	return (FIELD_LENGHT/REAL_LENGTH)*yCM;
}


void simulerImage(int xB, int yB, int xR0, int yR0, int xR1, int yR1)
{
	struct msgImageToIa msg;
	msg.mtype = 1;
	msg.xBall = xB;
	msg.yBall = yB;
	msg.xLeftRobot = xR0;
	msg.yLeftRobot = yR0;
	msg.xRightRobot = xR1;
	msg.yRightRobot = yR1;
	msgsnd(msgQueueImageToIa, &msg, sizeof(struct msgImageToIa)-sizeof(long), 0);

}

